aboutsummaryrefslogtreecommitdiffstats
path: root/rc.d/rcS.d
diff options
context:
space:
mode:
authorHarald Hoyer <harald@redhat.com>2010-08-03 18:14:03 +0200
committerHarald Hoyer <harald@redhat.com>2010-08-03 18:21:38 +0200
commit34dd409cb1199e3573655293475a76beb86931cd (patch)
treebacd86bd6923ac5c0147411305425fc7f5ca1237 /rc.d/rcS.d
parente127d5bcfe2e0175e88e8afdd644ee05a22538a5 (diff)
downloadinitscripts-9.16.0.2.systemd-1.tar
initscripts-9.16.0.2.systemd-1.tar.gz
initscripts-9.16.0.2.systemd-1.tar.bz2
initscripts-9.16.0.2.systemd-1.tar.xz
initscripts-9.16.0.2.systemd-1.zip
add systemd servicesinitscripts-9.16.0.2.systemd-1
Diffstat (limited to 'rc.d/rcS.d')
-rwxr-xr-xrc.d/rcS.d/010-hostname.sh11
-rwxr-xr-xrc.d/rcS.d/020-mountbasic.sh11
-rwxr-xr-xrc.d/rcS.d/030-welcome.sh28
-rwxr-xr-xrc.d/rcS.d/040-setmodprobe.sh14
-rwxr-xr-xrc.d/rcS.d/050-loglevel.sh8
-rwxr-xr-xrc.d/rcS.d/060-taskaffinity.sh15
-rwxr-xr-xrc.d/rcS.d/070-startudev.sh3
-rwxr-xr-xrc.d/rcS.d/080-devpts.sh15
-rwxr-xr-xrc.d/rcS.d/090-loadmodules.sh12
-rwxr-xr-xrc.d/rcS.d/100-kernelparam.sh7
-rwxr-xr-xrc.d/rcS.d/110-waitscan.sh4
-rwxr-xr-xrc.d/rcS.d/120-loaddmmod.sh8
-rwxr-xr-xrc.d/rcS.d/130-initcrypto1.sh7
-rwxr-xr-xrc.d/rcS.d/140-multipath.sh13
-rwxr-xr-xrc.d/rcS.d/150-dmraid.sh19
-rwxr-xr-xrc.d/rcS.d/160-mdraid.sh4
-rwxr-xr-xrc.d/rcS.d/170-lvm.sh7
-rwxr-xr-xrc.d/rcS.d/180-initcrypto2.sh7
-rwxr-xr-xrc.d/rcS.d/190-mountall.sh314
-rwxr-xr-xrc.d/rcS.d/200-quota.sh12
-rwxr-xr-xrc.d/rcS.d/210-selinuxrelabel.sh74
-rwxr-xr-xrc.d/rcS.d/220-random.sh28
-rwxr-xr-xrc.d/rcS.d/230-initcrypto3.sh7
-rwxr-xr-xrc.d/rcS.d/240-configure.sh39
-rwxr-xr-xrc.d/rcS.d/250-cleanup.sh56
-rwxr-xr-xrc.d/rcS.d/260-swap.sh8
-rwxr-xr-xrc.d/rcS.d/270-autoswap.sh16
-rwxr-xr-xrc.d/rcS.d/300-binfmtmisc.sh4
-rwxr-xr-xrc.d/rcS.d/310-autofsck.sh4
-rwxr-xr-xrc.d/rcS.d/320-getkey.sh7
-rwxr-xr-xrc.d/rcS.d/330-dmesg.sh6
-rwxr-xr-xrc.d/rcS.d/990-sysinitend.sh6
32 files changed, 774 insertions, 0 deletions
diff --git a/rc.d/rcS.d/010-hostname.sh b/rc.d/rcS.d/010-hostname.sh
new file mode 100755
index 00000000..713a3a37
--- /dev/null
+++ b/rc.d/rcS.d/010-hostname.sh
@@ -0,0 +1,11 @@
+#!/bin/sh
+HOSTNAME=$(/bin/hostname)
+
+if [ -f /etc/sysconfig/network ]; then
+ . /etc/sysconfig/network
+fi
+if [ -z "$HOSTNAME" -o "$HOSTNAME" = "(none)" ]; then
+ HOSTNAME=localhost
+fi
+hostname ${HOSTNAME}
+:
diff --git a/rc.d/rcS.d/020-mountbasic.sh b/rc.d/rcS.d/020-mountbasic.sh
new file mode 100755
index 00000000..9448be61
--- /dev/null
+++ b/rc.d/rcS.d/020-mountbasic.sh
@@ -0,0 +1,11 @@
+#!/bin/sh
+if [ ! -e /proc/mounts ]; then
+ mount -n -t proc /proc /proc
+ mount -n -t sysfs /sys /sys >/dev/null 2>&1
+fi
+if [ ! -d /proc/bus/usb ]; then
+ modprobe usbcore >/dev/null 2>&1 && mount -n -t usbfs /proc/bus/usb /proc/bus/usb
+else
+ mount -n -t usbfs /proc/bus/usb /proc/bus/usb
+fi
+:
diff --git a/rc.d/rcS.d/030-welcome.sh b/rc.d/rcS.d/030-welcome.sh
new file mode 100755
index 00000000..e7d8248c
--- /dev/null
+++ b/rc.d/rcS.d/030-welcome.sh
@@ -0,0 +1,28 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
+
+# Print a text banner.
+echo -en $"\t\tWelcome to "
+read -r system_release < /etc/system-release
+if [[ "$system_release" == *"Red Hat"* ]]; then
+ [ "$BOOTUP" = "color" ] && echo -en "\\033[0;31m"
+ echo -en "Red Hat"
+ [ "$BOOTUP" = "color" ] && echo -en "\\033[0;39m"
+ PRODUCT=$(sed "s/Red Hat \(.*\) release.*/\1/" /etc/system-release)
+ echo " $PRODUCT"
+elif [[ "$system_release" == *Fedora* ]]; then
+ [ "$BOOTUP" = "color" ] && echo -en "\\033[0;34m"
+ echo -en "Fedora"
+ [ "$BOOTUP" = "color" ] && echo -en "\\033[0;39m"
+ PRODUCT=$(sed "s/Fedora \(.*\) \?release.*/\1/" /etc/system-release)
+ echo " $PRODUCT"
+else
+ PRODUCT=$(sed "s/ release.*//g" /etc/system-release)
+ echo "$PRODUCT"
+fi
+if [ "$PROMPT" != "no" ]; then
+ echo -en $"\t\tPress 'I' to enter interactive startup."
+ echo
+fi
+:
diff --git a/rc.d/rcS.d/040-setmodprobe.sh b/rc.d/rcS.d/040-setmodprobe.sh
new file mode 100755
index 00000000..66003357
--- /dev/null
+++ b/rc.d/rcS.d/040-setmodprobe.sh
@@ -0,0 +1,14 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
+
+# Initialize hardware
+if [ -f /proc/sys/kernel/modprobe ]; then
+ if ! strstr "$cmdline" nomodules && [ -f /proc/modules ] ; then
+ sysctl -w kernel.modprobe="/sbin/modprobe" >/dev/null 2>&1
+ else
+ # We used to set this to NULL, but that causes 'failed to exec' messages"
+ sysctl -w kernel.modprobe="/bin/true" >/dev/null 2>&1
+ fi
+fi
+:
diff --git a/rc.d/rcS.d/050-loglevel.sh b/rc.d/rcS.d/050-loglevel.sh
new file mode 100755
index 00000000..6e88b4f7
--- /dev/null
+++ b/rc.d/rcS.d/050-loglevel.sh
@@ -0,0 +1,8 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+
+# Fix console loglevel
+if [ -n "$LOGLEVEL" ]; then
+ /bin/dmesg -n $LOGLEVEL
+fi
+:
diff --git a/rc.d/rcS.d/060-taskaffinity.sh b/rc.d/rcS.d/060-taskaffinity.sh
new file mode 100755
index 00000000..c8045d40
--- /dev/null
+++ b/rc.d/rcS.d/060-taskaffinity.sh
@@ -0,0 +1,15 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
+
+# Set default affinity
+if [ -x /bin/taskset ]; then
+ if strstr "$cmdline" default_affinity= ; then
+ for arg in $cmdline ; do
+ if [ "${arg##default_affinity=}" != "${arg}" ]; then
+ /bin/taskset -p ${arg##default_affinity=} 1
+ fi
+ done
+ fi
+fi
+:
diff --git a/rc.d/rcS.d/070-startudev.sh b/rc.d/rcS.d/070-startudev.sh
new file mode 100755
index 00000000..04874038
--- /dev/null
+++ b/rc.d/rcS.d/070-startudev.sh
@@ -0,0 +1,3 @@
+#!/bin/sh
+/sbin/start_udev
+:
diff --git a/rc.d/rcS.d/080-devpts.sh b/rc.d/rcS.d/080-devpts.sh
new file mode 100755
index 00000000..d2fa937a
--- /dev/null
+++ b/rc.d/rcS.d/080-devpts.sh
@@ -0,0 +1,15 @@
+#!/bin/sh
+# Check SELinux status
+SELINUX_STATE=
+if [ -e "/selinux/enforce" ] && [ "$(cat /proc/self/attr/current)" != "kernel" ]; then
+ if [ -r "/selinux/enforce" ] ; then
+ SELINUX_STATE=$(cat "/selinux/enforce")
+ else
+ # assume enforcing if you can't read it
+ SELINUX_STATE=1
+ fi
+fi
+
+mount -n /dev/pts >/dev/null 2>&1
+[ -n "$SELINUX_STATE" ] && restorecon /dev/pts >/dev/null 2>&1
+:
diff --git a/rc.d/rcS.d/090-loadmodules.sh b/rc.d/rcS.d/090-loadmodules.sh
new file mode 100755
index 00000000..4ad4bbad
--- /dev/null
+++ b/rc.d/rcS.d/090-loadmodules.sh
@@ -0,0 +1,12 @@
+#!/bin/sh
+
+# Load other user-defined modules
+for file in /etc/sysconfig/modules/*.modules ; do
+ [ -x $file ] && $file
+done
+
+# Load modules (for backward compatibility with VARs)
+if [ -f /etc/rc.modules ]; then
+ /etc/rc.modules
+fi
+:
diff --git a/rc.d/rcS.d/100-kernelparam.sh b/rc.d/rcS.d/100-kernelparam.sh
new file mode 100755
index 00000000..36728c95
--- /dev/null
+++ b/rc.d/rcS.d/100-kernelparam.sh
@@ -0,0 +1,7 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+
+# Configure kernel parameters
+update_boot_stage RCkernelparam
+sysctl -e -p /etc/sysctl.conf >/dev/null 2>&1
+:
diff --git a/rc.d/rcS.d/110-waitscan.sh b/rc.d/rcS.d/110-waitscan.sh
new file mode 100755
index 00000000..db083320
--- /dev/null
+++ b/rc.d/rcS.d/110-waitscan.sh
@@ -0,0 +1,4 @@
+#!/bin/sh
+# Sync waiting for storage.
+{ rmmod scsi_wait_scan ; modprobe scsi_wait_scan ; rmmod scsi_wait_scan ; } >/dev/null 2>&1
+:
diff --git a/rc.d/rcS.d/120-loaddmmod.sh b/rc.d/rcS.d/120-loaddmmod.sh
new file mode 100755
index 00000000..4696af97
--- /dev/null
+++ b/rc.d/rcS.d/120-loaddmmod.sh
@@ -0,0 +1,8 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+
+# Device mapper & related initialization
+if ! __fgrep "device-mapper" /proc/devices >/dev/null 2>&1 ; then
+ modprobe dm-mod >/dev/null 2>&1
+fi
+:
diff --git a/rc.d/rcS.d/130-initcrypto1.sh b/rc.d/rcS.d/130-initcrypto1.sh
new file mode 100755
index 00000000..dd1ba876
--- /dev/null
+++ b/rc.d/rcS.d/130-initcrypto1.sh
@@ -0,0 +1,7 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+
+if [ -f /etc/crypttab ]; then
+ init_crypto 0
+fi
+:
diff --git a/rc.d/rcS.d/140-multipath.sh b/rc.d/rcS.d/140-multipath.sh
new file mode 100755
index 00000000..83fc0d8f
--- /dev/null
+++ b/rc.d/rcS.d/140-multipath.sh
@@ -0,0 +1,13 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
+
+if ! strstr "$cmdline" nompath && [ -f /etc/multipath.conf ] && \
+ [ -x /sbin/multipath ]; then
+ modprobe dm-multipath > /dev/null 2>&1
+ /sbin/multipath -v 0
+ if [ -x /sbin/kpartx ]; then
+ /sbin/dmsetup ls --target multipath --exec "/sbin/kpartx -a -p p" >/dev/null
+ fi
+fi
+:
diff --git a/rc.d/rcS.d/150-dmraid.sh b/rc.d/rcS.d/150-dmraid.sh
new file mode 100755
index 00000000..f983e4e9
--- /dev/null
+++ b/rc.d/rcS.d/150-dmraid.sh
@@ -0,0 +1,19 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
+
+if ! strstr "$cmdline" nodmraid && [ -x /sbin/dmraid ]; then
+ modprobe dm-mirror >/dev/null 2>&1
+ dmraidsets=$(LC_ALL=C /sbin/dmraid -s -c -i)
+ if [ "$?" = "0" ]; then
+ for dmname in $dmraidsets; do
+ if [[ "$dmname" == isw_* ]] && \
+ ! strstr "$cmdline" noiswmd; then
+ continue
+ fi
+ /sbin/dmraid -ay -i --rm_partitions -p "$dmname" >/dev/null 2>&1
+ /sbin/kpartx -a -p p "/dev/mapper/$dmname"
+ done
+ fi
+fi
+:
diff --git a/rc.d/rcS.d/160-mdraid.sh b/rc.d/rcS.d/160-mdraid.sh
new file mode 100755
index 00000000..1a0b065e
--- /dev/null
+++ b/rc.d/rcS.d/160-mdraid.sh
@@ -0,0 +1,4 @@
+#!/bin/sh
+# Start any MD RAID arrays that haven't been started yet
+[ -r /proc/mdstat -a -r /dev/md/md-device-map ] && /sbin/mdadm -IRs
+:
diff --git a/rc.d/rcS.d/170-lvm.sh b/rc.d/rcS.d/170-lvm.sh
new file mode 100755
index 00000000..da4bd84d
--- /dev/null
+++ b/rc.d/rcS.d/170-lvm.sh
@@ -0,0 +1,7 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
+if [ -x /sbin/lvm ]; then
+ action $"Setting up Logical Volume Management:" /sbin/lvm vgchange -a y --sysinit
+fi
+:
diff --git a/rc.d/rcS.d/180-initcrypto2.sh b/rc.d/rcS.d/180-initcrypto2.sh
new file mode 100755
index 00000000..dd1ba876
--- /dev/null
+++ b/rc.d/rcS.d/180-initcrypto2.sh
@@ -0,0 +1,7 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+
+if [ -f /etc/crypttab ]; then
+ init_crypto 0
+fi
+:
diff --git a/rc.d/rcS.d/190-mountall.sh b/rc.d/rcS.d/190-mountall.sh
new file mode 100755
index 00000000..11e554e9
--- /dev/null
+++ b/rc.d/rcS.d/190-mountall.sh
@@ -0,0 +1,314 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
+
+# Check SELinux status
+SELINUX_STATE=
+if [ -e "/selinux/enforce" ] && [ "$(cat /proc/self/attr/current)" != "kernel" ]; then
+ if [ -r "/selinux/enforce" ] ; then
+ SELINUX_STATE=$(cat "/selinux/enforce")
+ else
+ # assume enforcing if you can't read it
+ SELINUX_STATE=1
+ fi
+fi
+
+disable_selinux() {
+ echo $"*** Warning -- SELinux is active"
+ echo $"*** Disabling security enforcement for system recovery."
+ echo $"*** Run 'setenforce 1' to reenable."
+ echo "0" > "/selinux/enforce"
+}
+
+if [ -f /fsckoptions ]; then
+ fsckoptions=$(cat /fsckoptions)
+fi
+
+if [ -f /forcefsck ] || strstr "$cmdline" forcefsck ; then
+ fsckoptions="-f $fsckoptions"
+elif [ -f /.autofsck ]; then
+ [ -f /etc/sysconfig/autofsck ] && . /etc/sysconfig/autofsck
+ if [ "$AUTOFSCK_DEF_CHECK" = "yes" ]; then
+ AUTOFSCK_OPT="$AUTOFSCK_OPT -f"
+ fi
+ if [ -n "$AUTOFSCK_SINGLEUSER" ]; then
+ [ type -p plymouth &>/dev/null ] && plymouth --hide-splash
+ echo
+ echo $"*** Warning -- the system did not shut down cleanly. "
+ echo $"*** Dropping you to a shell; the system will continue"
+ echo $"*** when you leave the shell."
+ [ -n "$SELINUX_STATE" ] && echo "0" > /selinux/enforce
+ sulogin
+ [ -n "$SELINUX_STATE" ] && echo "1" > /selinux/enforce
+ [ type -p plymouth &>/dev/null ] && plymouth --show-splash
+ fi
+ fsckoptions="$AUTOFSCK_OPT $fsckoptions"
+fi
+
+if [ "$BOOTUP" = "color" ]; then
+ fsckoptions="-C $fsckoptions"
+else
+ fsckoptions="-V $fsckoptions"
+fi
+
+READONLY=no
+if [ -f /etc/sysconfig/readonly-root ]; then
+ . /etc/sysconfig/readonly-root
+fi
+if strstr "$cmdline" readonlyroot ; then
+ READONLY=yes
+ [ -z "$RW_MOUNT" ] && RW_MOUNT=/var/lib/stateless/writable
+ [ -z "$STATE_MOUNT" ] && STATE_MOUNT=/var/lib/stateless/state
+fi
+if strstr "$cmdline" noreadonlyroot ; then
+ READONLY=no
+fi
+
+if [ "$READONLY" = "yes" -o "$TEMPORARY_STATE" = "yes" ]; then
+
+ mount_empty() {
+ if [ -e "$1" ]; then
+ echo "$1" | cpio -p -vd "$RW_MOUNT" &>/dev/null
+ mount -n --bind "$RW_MOUNT$1" "$1"
+ fi
+ }
+
+ mount_dirs() {
+ if [ -e "$1" ]; then
+ mkdir -p "$RW_MOUNT$1"
+ find "$1" -type d -print0 | cpio -p -0vd "$RW_MOUNT" &>/dev/null
+ mount -n --bind "$RW_MOUNT$1" "$1"
+ fi
+ }
+
+ mount_files() {
+ if [ -e "$1" ]; then
+ cp -a --parents "$1" "$RW_MOUNT"
+ mount -n --bind "$RW_MOUNT$1" "$1"
+ fi
+ }
+
+ # Common mount options for scratch space regardless of
+ # type of backing store
+ mountopts=
+
+ # Scan partitions for local scratch storage
+ rw_mount_dev=$(blkid -t LABEL="$RW_LABEL" -l -o device)
+
+ # First try to mount scratch storage from /etc/fstab, then any
+ # partition with the proper label. If either succeeds, be sure
+ # to wipe the scratch storage clean. If both fail, then mount
+ # scratch storage via tmpfs.
+ if mount $mountopts "$RW_MOUNT" > /dev/null 2>&1 ; then
+ rm -rf "$RW_MOUNT" > /dev/null 2>&1
+ elif [ x$rw_mount_dev != x ] && mount $rw_mount_dev $mountopts "$RW_MOUNT" > /dev/null 2>&1; then
+ rm -rf "$RW_MOUNT" > /dev/null 2>&1
+ else
+ mount -n -t tmpfs $RW_OPTIONS $mountopts none "$RW_MOUNT"
+ fi
+
+ for file in /etc/rwtab /etc/rwtab.d/* /dev/.initramfs/rwtab ; do
+ is_ignored_file "$file" && continue
+ [ -f $file ] && cat $file | while read type path ; do
+ case "$type" in
+ empty)
+ mount_empty $path
+ ;;
+ files)
+ mount_files $path
+ ;;
+ dirs)
+ mount_dirs $path
+ ;;
+ *)
+ ;;
+ esac
+ [ -n "$SELINUX_STATE" ] && [ -e "$path" ] && restorecon -R "$path"
+ done
+ done
+
+ # Use any state passed by initramfs
+ [ -d /dev/.initramfs/state ] && cp -a /dev/.initramfs/state/* $RW_MOUNT
+
+ # In theory there should be no more than one network interface active
+ # this early in the boot process -- the one we're booting from.
+ # Use the network address to set the hostname of the client. This
+ # must be done even if we have local storage.
+ ipaddr=
+ if [ "$HOSTNAME" = "localhost" -o "$HOSTNAME" = "localhost.localdomain" ]; then
+ ipaddr=$(ip addr show to 0.0.0.0/0 scope global | awk '/[[:space:]]inet / { print gensub("/.*","","g",$2) }')
+ for ip in $ipaddr ; do
+ HOSTNAME=
+ eval $(ipcalc -h $ipaddr 2>/dev/null)
+ [ -n "$HOSTNAME" ] && { hostname ${HOSTNAME} ; break; }
+ done
+ fi
+
+ # Clients with read-only root filesystems may be provided with a
+ # place where they can place minimal amounts of persistent
+ # state. SSH keys or puppet certificates for example.
+ #
+ # Ideally we'll use puppet to manage the state directory and to
+ # create the bind mounts. However, until that's all ready this
+ # is sufficient to build a working system.
+
+ # First try to mount persistent data from /etc/fstab, then any
+ # partition with the proper label, then fallback to NFS
+ state_mount_dev=$(blkid -t LABEL="$STATE_LABEL" -l -o device)
+ if mount $mountopts $STATE_OPTIONS "$STATE_MOUNT" > /dev/null 2>&1 ; then
+ /bin/true
+ elif [ x$state_mount_dev != x ] && mount $state_mount_dev $mountopts "$STATE_MOUNT" > /dev/null 2>&1; then
+ /bin/true
+ elif [ ! -z "$CLIENTSTATE" ]; then
+ # No local storage was found. Make a final attempt to find
+ # state on an NFS server.
+
+ mount -t nfs $CLIENTSTATE/$HOSTNAME $STATE_MOUNT -o rw,nolock
+ fi
+
+ if [ -w "$STATE_MOUNT" ]; then
+
+ mount_state() {
+ if [ -e "$1" ]; then
+ [ ! -e "$STATE_MOUNT$1" ] && cp -a --parents "$1" "$STATE_MOUNT"
+ mount -n --bind "$STATE_MOUNT$1" "$1"
+ fi
+ }
+
+ for file in /etc/statetab /etc/statetab.d/* ; do
+ is_ignored_file "$file" && continue
+ [ ! -f "$file" ] && continue
+
+ if [ -f "$STATE_MOUNT/$file" ] ; then
+ mount -n --bind "$STATE_MOUNT/$file" "$file"
+ fi
+
+ for path in $(grep -v "^#" "$file" 2>/dev/null); do
+ mount_state "$path"
+ [ -n "$SELINUX_STATE" ] && [ -e "$path" ] && restorecon -R "$path"
+ done
+ done
+
+ if [ -f "$STATE_MOUNT/files" ] ; then
+ for path in $(grep -v "^#" "$STATE_MOUNT/files" 2>/dev/null); do
+ mount_state "$path"
+ [ -n "$SELINUX_STATE" ] && [ -e "$path" ] && restorecon -R "$path"
+ done
+ fi
+ fi
+fi
+
+if [[ " $fsckoptions" != *" -y"* ]]; then
+ fsckoptions="-a $fsckoptions"
+fi
+
+if [ -f /fastboot ] || strstr "$cmdline" fastboot ; then
+ fastboot=yes
+fi
+if [ -z "$fastboot" -a "$READONLY" != "yes" ]; then
+
+ STRING=$"Checking filesystems"
+ echo $STRING
+ fsck -T -t noopts=_netdev -A $fsckoptions
+ rc=$?
+
+ if [ "$rc" -eq "0" ]; then
+ success "$STRING"
+ echo
+ elif [ "$rc" -eq "1" ]; then
+ passed "$STRING"
+ echo
+ elif [ "$rc" -eq "2" -o "$rc" -eq "3" ]; then
+ echo $"Unmounting file systems"
+ umount -a
+ mount -n -o remount,ro /
+ echo $"Automatic reboot in progress."
+ reboot -f
+ fi
+
+ # A return of 4 or higher means there were serious problems.
+ if [ $rc -gt 1 ]; then
+ [ type -p plymouth &>/dev/null ] && plymouth --hide-splash
+
+ failure "$STRING"
+ echo
+ echo
+ echo $"*** An error occurred during the file system check."
+ echo $"*** Dropping you to a shell; the system will reboot"
+ echo $"*** when you leave the shell."
+
+ str=$"(Repair filesystem)"
+ PS1="$str \# # "; export PS1
+ [ "$SELINUX_STATE" = "1" ] && disable_selinux
+ sulogin
+
+ echo $"Unmounting file systems"
+ umount -a
+ mount -n -o remount,ro /
+ echo $"Automatic reboot in progress."
+ reboot -f
+ elif [ "$rc" -eq "1" ]; then
+ _RUN_QUOTACHECK=1
+ fi
+fi
+
+remount_needed() {
+ local state oldifs
+ [ "$READONLY" = "yes" ] && return 1
+ state=$(LC_ALL=C awk '/ \/ / && ($3 !~ /rootfs/) { print $4 }' /proc/mounts)
+ oldifs=$IFS
+ IFS=","
+ for opt in $state ; do
+ if [ "$opt" = "rw" ]; then
+ IFS=$oldifs
+ return 1
+ fi
+ done
+ IFS=$oldifs
+ return 0
+}
+
+# Remount the root filesystem read-write.
+update_boot_stage RCmountfs
+if remount_needed ; then
+ action $"Remounting root filesystem in read-write mode: " mount -n -o remount,rw /
+fi
+
+# Clean up SELinux labels
+if [ -n "$SELINUX_STATE" ]; then
+ restorecon /etc/mtab /etc/ld.so.cache /etc/blkid/blkid.tab /etc/resolv.conf >/dev/null 2>&1
+fi
+
+# If relabeling, relabel mount points.
+if [ -n "$SELINUX_STATE" -a "$READONLY" != "yes" ]; then
+ if strstr "$cmdline" autorelabel || [ -f /.autorelabel ] ; then
+ restorecon $(awk '!/^#/ && $4 !~ /noauto/ && $2 ~ /^\// { print $2 }' /etc/fstab) >/dev/null 2>&1
+ fi
+fi
+
+if [ "$READONLY" != "yes" ] ; then
+ # Clear mtab
+ (> /etc/mtab) &> /dev/null
+
+ # Remove stale backups
+ rm -f /etc/mtab~ /etc/mtab~~
+
+ # Enter mounted filesystems into /etc/mtab
+ mount -f /
+ mount -f /proc >/dev/null 2>&1
+ mount -f /sys >/dev/null 2>&1
+ mount -f /dev/pts >/dev/null 2>&1
+ mount -f /dev/shm >/dev/null 2>&1
+ mount -f /proc/bus/usb >/dev/null 2>&1
+fi
+
+# Mount all other filesystems (except for NFS and /proc, which is already
+# mounted). Contrary to standard usage,
+# filesystems are NOT unmounted in single user mode.
+if [ "$READONLY" != "yes" ] ; then
+ action $"Mounting local filesystems: " mount -a -t nonfs,nfs4,smbfs,ncpfs,cifs,gfs,gfs2 -O no_netdev
+else
+ action $"Mounting local filesystems: " mount -a -n -t nonfs,nfs4,smbfs,ncpfs,cifs,gfs,gfs2 -O no_netdev
+fi
+
+[[ $_RUN_QUOTACHECK = 1 ]] && touch /forcequotacheck:
diff --git a/rc.d/rcS.d/200-quota.sh b/rc.d/rcS.d/200-quota.sh
new file mode 100755
index 00000000..bc7ee758
--- /dev/null
+++ b/rc.d/rcS.d/200-quota.sh
@@ -0,0 +1,12 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
+
+if [ -x /sbin/quotacheck ] && { strstr "$cmdline" forcequotacheck || [ -f /forcequotacheck ]; } ; then
+ action $"Checking local filesystem quotas: " /sbin/quotacheck -anug
+fi
+
+if [ -x /sbin/quotaon ]; then
+ action $"Enabling local filesystem quotas: " /sbin/quotaon -aug
+fi
+:
diff --git a/rc.d/rcS.d/210-selinuxrelabel.sh b/rc.d/rcS.d/210-selinuxrelabel.sh
new file mode 100755
index 00000000..9ce86d9a
--- /dev/null
+++ b/rc.d/rcS.d/210-selinuxrelabel.sh
@@ -0,0 +1,74 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
+
+READONLY=no
+if [ -f /etc/sysconfig/readonly-root ]; then
+ . /etc/sysconfig/readonly-root
+fi
+if strstr "$cmdline" readonlyroot ; then
+ READONLY=yes
+ [ -z "$RW_MOUNT" ] && RW_MOUNT=/var/lib/stateless/writable
+ [ -z "$STATE_MOUNT" ] && STATE_MOUNT=/var/lib/stateless/state
+fi
+if strstr "$cmdline" noreadonlyroot ; then
+ READONLY=no
+fi
+
+# Check SELinux status
+SELINUX_STATE=
+if [ -e "/selinux/enforce" ] && [ "$(cat /proc/self/attr/current)" != "kernel" ]; then
+ if [ -r "/selinux/enforce" ] ; then
+ SELINUX_STATE=$(cat "/selinux/enforce")
+ else
+ # assume enforcing if you can't read it
+ SELINUX_STATE=1
+ fi
+fi
+
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
+
+relabel_selinux() {
+ # if /sbin/init is not labeled correctly this process is running in the
+ # wrong context, so a reboot will be required after relabel
+ AUTORELABEL=
+ . /etc/selinux/config
+ echo "0" > /selinux/enforce
+ [ type -p plymouth &>/dev/null ] && plymouth --hide-splash
+
+ if [ "$AUTORELABEL" = "0" ]; then
+ echo
+ echo $"*** Warning -- SELinux ${SELINUXTYPE} policy relabel is required. "
+ echo $"*** /etc/selinux/config indicates you want to manually fix labeling"
+ echo $"*** problems. Dropping you to a shell; the system will reboot"
+ echo $"*** when you leave the shell."
+ sulogin
+
+ else
+ echo
+ echo $"*** Warning -- SELinux ${SELINUXTYPE} policy relabel is required."
+ echo $"*** Relabeling could take a very long time, depending on file"
+ echo $"*** system size and speed of hard drives."
+
+ /sbin/fixfiles -F restore > /dev/null 2>&1
+ fi
+ rm -f /.autorelabel
+ echo $"Unmounting file systems"
+ umount -a
+ mount -n -o remount,ro /
+ echo $"Automatic reboot in progress."
+ reboot -f
+}
+
+# Check to see if a full relabel is needed
+if [ -n "$SELINUX_STATE" -a "$READONLY" != "yes" ]; then
+ if strstr "$cmdline" autorelabel || [ -f /.autorelabel ] ; then
+ relabel_selinux
+ fi
+else
+ if [ "$READONLY" != "yes" ] && [ -d /etc/selinux ]; then
+ [ -f /.autorelabel ] || touch /.autorelabel
+ fi
+fi
+:
diff --git a/rc.d/rcS.d/220-random.sh b/rc.d/rcS.d/220-random.sh
new file mode 100755
index 00000000..fa1102ad
--- /dev/null
+++ b/rc.d/rcS.d/220-random.sh
@@ -0,0 +1,28 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
+
+READONLY=no
+if [ -f /etc/sysconfig/readonly-root ]; then
+ . /etc/sysconfig/readonly-root
+fi
+if strstr "$cmdline" readonlyroot ; then
+ READONLY=yes
+ [ -z "$RW_MOUNT" ] && RW_MOUNT=/var/lib/stateless/writable
+ [ -z "$STATE_MOUNT" ] && STATE_MOUNT=/var/lib/stateless/state
+fi
+if strstr "$cmdline" noreadonlyroot ; then
+ READONLY=no
+fi
+
+# Initialize pseudo-random number generator
+if [ -f "/var/lib/random-seed" ]; then
+ cat /var/lib/random-seed > /dev/urandom
+else
+ [ "$READONLY" != "yes" ] && touch /var/lib/random-seed
+fi
+if [ "$READONLY" != "yes" ]; then
+ chmod 600 /var/lib/random-seed
+ dd if=/dev/urandom of=/var/lib/random-seed count=1 bs=512 2>/dev/null
+fi
+:
diff --git a/rc.d/rcS.d/230-initcrypto3.sh b/rc.d/rcS.d/230-initcrypto3.sh
new file mode 100755
index 00000000..d7e7b757
--- /dev/null
+++ b/rc.d/rcS.d/230-initcrypto3.sh
@@ -0,0 +1,7 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+
+if [ -f /etc/crypttab ]; then
+ init_crypto 1
+fi
+:
diff --git a/rc.d/rcS.d/240-configure.sh b/rc.d/rcS.d/240-configure.sh
new file mode 100755
index 00000000..7cf87796
--- /dev/null
+++ b/rc.d/rcS.d/240-configure.sh
@@ -0,0 +1,39 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+
+# Configure machine if necessary.
+if [ -f /.unconfigured ]; then
+ if [ -x /usr/bin/rhgb-client ] && /usr/bin/rhgb-client --ping ; then
+ /usr/bin/rhgb-client --quit
+ fi
+
+ if [ -x /usr/bin/system-config-keyboard ]; then
+ /usr/bin/system-config-keyboard
+ fi
+ if [ -x /usr/bin/passwd ]; then
+ /usr/bin/passwd root
+ fi
+ if [ -x /usr/sbin/system-config-network-tui ]; then
+ /usr/sbin/system-config-network-tui
+ fi
+ if [ -x /usr/sbin/timeconfig ]; then
+ /usr/sbin/timeconfig
+ fi
+ if [ -x /usr/sbin/authconfig-tui ]; then
+ /usr/sbin/authconfig-tui --nostart
+ fi
+ if [ -x /usr/sbin/ntsysv ]; then
+ /usr/sbin/ntsysv --level 35
+ fi
+
+ # Reread in network configuration data.
+ if [ -f /etc/sysconfig/network ]; then
+ . /etc/sysconfig/network
+
+ # Reset the hostname.
+ action $"Resetting hostname ${HOSTNAME}: " hostname ${HOSTNAME}
+ fi
+
+ rm -f /.unconfigured
+fi
+:
diff --git a/rc.d/rcS.d/250-cleanup.sh b/rc.d/rcS.d/250-cleanup.sh
new file mode 100755
index 00000000..98b65101
--- /dev/null
+++ b/rc.d/rcS.d/250-cleanup.sh
@@ -0,0 +1,56 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
+
+# Check SELinux status
+SELINUX_STATE=
+if [ -e "/selinux/enforce" ] && [ "$(cat /proc/self/attr/current)" != "kernel" ]; then
+ if [ -r "/selinux/enforce" ] ; then
+ SELINUX_STATE=$(cat "/selinux/enforce")
+ else
+ # assume enforcing if you can't read it
+ SELINUX_STATE=1
+ fi
+fi
+
+# Clean out /.
+rm -f /fastboot /fsckoptions /forcefsck /.autofsck /forcequotacheck /halt \
+ /poweroff /.suspended &> /dev/null
+
+# Do we need (w|u)tmpx files? We don't set them up, but the sysadmin might...
+_NEED_XFILES=
+[ -f /var/run/utmpx ] || [ -f /var/log/wtmpx ] && _NEED_XFILES=1
+
+# Clean up /var.
+rm -rf /var/lock/cvs/* /var/run/screen/*
+find /var/lock /var/run ! -type d -exec rm -f {} \;
+rm -f /var/lib/rpm/__db* &> /dev/null
+rm -f /var/gdm/.gdmfifo &> /dev/null
+
+
+# Clean up utmp/wtmp
+> /var/run/utmp
+touch /var/log/wtmp
+chgrp utmp /var/run/utmp /var/log/wtmp
+chmod 0664 /var/run/utmp /var/log/wtmp
+if [ -n "$_NEED_XFILES" ]; then
+ > /var/run/utmpx
+ touch /var/log/wtmpx
+ chgrp utmp /var/run/utmpx /var/log/wtmpx
+ chmod 0664 /var/run/utmpx /var/log/wtmpx
+fi
+[ -n "$SELINUX_STATE" ] && restorecon /var/run/utmp* /var/log/wtmp* >/dev/null 2>&1
+
+# Clean up various /tmp bits
+[ -n "$SELINUX_STATE" ] && restorecon /tmp
+rm -f /tmp/.X*-lock /tmp/.lock.* /tmp/.gdm_socket /tmp/.s.PGSQL.*
+rm -rf /tmp/.X*-unix /tmp/.ICE-unix /tmp/.font-unix /tmp/hsperfdata_* \
+ /tmp/kde-* /tmp/ksocket-* /tmp/mc-* /tmp/mcop-* /tmp/orbit-* \
+ /tmp/scrollkeeper-* /tmp/ssh-* \
+ /dev/.in_sysinit
+
+# Make ICE directory
+mkdir -m 1777 -p /tmp/.ICE-unix >/dev/null 2>&1
+chown root:root /tmp/.ICE-unix
+[ -n "$SELINUX_STATE" ] && restorecon /tmp/.ICE-unix >/dev/null 2>&1
+:
diff --git a/rc.d/rcS.d/260-swap.sh b/rc.d/rcS.d/260-swap.sh
new file mode 100755
index 00000000..51a55f39
--- /dev/null
+++ b/rc.d/rcS.d/260-swap.sh
@@ -0,0 +1,8 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+
+# Start up swapping.
+update_boot_stage RCswap
+action $"Enabling /etc/fstab swaps: " swapon -a -e
+
+:
diff --git a/rc.d/rcS.d/270-autoswap.sh b/rc.d/rcS.d/270-autoswap.sh
new file mode 100755
index 00000000..e7ce922e
--- /dev/null
+++ b/rc.d/rcS.d/270-autoswap.sh
@@ -0,0 +1,16 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+
+# Start up swapping.
+if [ "$AUTOSWAP" = "yes" ]; then
+ curswap=$(awk '/^\/dev/ { print $1 }' /proc/swaps | while read x; do get_numeric_dev dec $x ; echo -n " "; done)
+ swappartitions=$(blkid -t TYPE=swap -o device)
+ if [ x"$swappartitions" != x ]; then
+ for partition in $swappartitions ; do
+ [ ! -e $partition ] && continue
+ majmin=$(get_numeric_dev dec $partition)
+ echo $curswap | grep -qw "$majmin" || action $"Enabling local swap partitions: " swapon $partition
+ done
+ fi
+fi
+:
diff --git a/rc.d/rcS.d/300-binfmtmisc.sh b/rc.d/rcS.d/300-binfmtmisc.sh
new file mode 100755
index 00000000..b27148af
--- /dev/null
+++ b/rc.d/rcS.d/300-binfmtmisc.sh
@@ -0,0 +1,4 @@
+#!/bin/sh
+# Set up binfmt_misc
+/bin/mount -t binfmt_misc none /proc/sys/fs/binfmt_misc > /dev/null 2>&1
+:
diff --git a/rc.d/rcS.d/310-autofsck.sh b/rc.d/rcS.d/310-autofsck.sh
new file mode 100755
index 00000000..ebf8717a
--- /dev/null
+++ b/rc.d/rcS.d/310-autofsck.sh
@@ -0,0 +1,4 @@
+#!/bin/sh
+# create the crash indicator flag to warn on crashes, offer fsck with timeout
+touch /.autofsck &> /dev/null
+:
diff --git a/rc.d/rcS.d/320-getkey.sh b/rc.d/rcS.d/320-getkey.sh
new file mode 100755
index 00000000..61daee16
--- /dev/null
+++ b/rc.d/rcS.d/320-getkey.sh
@@ -0,0 +1,7 @@
+#!/bin/sh
+[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
+[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
+
+if strstr "$cmdline" confirm ; then
+ touch /var/run/confirm
+fi
diff --git a/rc.d/rcS.d/330-dmesg.sh b/rc.d/rcS.d/330-dmesg.sh
new file mode 100755
index 00000000..42fb0efe
--- /dev/null
+++ b/rc.d/rcS.d/330-dmesg.sh
@@ -0,0 +1,6 @@
+#!/bin/sh
+# Now that we have all of our basic modules loaded and the kernel going,
+# let's dump the syslog ring somewhere so we can find it later
+[ -f /var/log/dmesg ] && mv -f /var/log/dmesg /var/log/dmesg.old
+dmesg -s 131072 > /var/log/dmesg
+:
diff --git a/rc.d/rcS.d/990-sysinitend.sh b/rc.d/rcS.d/990-sysinitend.sh
new file mode 100755
index 00000000..f79d0995
--- /dev/null
+++ b/rc.d/rcS.d/990-sysinitend.sh
@@ -0,0 +1,6 @@
+#!/bin/sh
+# Let rhgb know that we're leaving rc.sysinit
+if [ -x /usr/bin/rhgb-client ] && /usr/bin/rhgb-client --ping ; then
+ /usr/bin/rhgb-client --sysinit
+fi
+: